	@program prog_code,prog_name
	include macros.h
	

;**************** Start of Fargo Program *************
prog_code:
	jsr		flib[clr_scr]
	move.w		#24,wh_x1		;First X Coordinate of White Key
	move.w		#16,wh_y1		;First Y Coordinate of White Key
	move.w		#0,blk_done		;Plotting check
	move.l		#$4440,a0		;Screen address

WhiteKeys:
	move.w		wh_x1,d0		;For LineLib    
	move.w		wh_y1,d1		;
	move.w		wh_x1,d2		;
	move.w		wh_y1,d3		;
	add.w		#24,d2			;Increment x value
	jsr		linelib[fline]		;Draw line
	move.w		wh_x1,d2		;
	add.w		#90,d3			;Increment y value
	jsr		linelib[fline]		;Draw line
	add.w		#90,d1
	add.w		#24,d2			;Increment x value
	jsr		linelib[fline]		;Draw line
	cmp.w		#216,d2			;Are we at the right side?
	bge		Finish_Draw		;If so goto finish_draw
	add.w		#24,wh_x1		;Increment the x value
	bra		WhiteKeys		;Goto WhiteKeys

Finish_Draw:
	move.w		#216,d0			;Finish far right side
	move.w		#16,d1
	jsr		linelib[fline]

Black_Key:
	move.w		#16,d1			;Move base y1 address in
	move.w		#76,d3			;Move base y2 address in
	move.w		#40,d0			;Various x1 values
	bsr		Black_Key_Fill
	move.w		#64,d0
	bsr		Black_Key_Fill
	move.w		#112,d0
	bsr		Black_Key_Fill
	move.w		#136,d0
	bsr		Black_Key_Fill
	move.w		#160,d0
	bsr		Black_Key_Fill
	bra		Text

Black_Key_Fill:
	move.w		d0,d2			;Copy x1 value
	jsr		linelib[fline]		;Draw the line
	add.w		#1,d0			;Increment x1's value
	add.w		#1,blk_done		;Increment the check variable's value
	cmp.w		#16,blk_done		;Compare the value to see if finished
	blt		Black_Key_Fill		;If not, do it again
	move.w		#0,blk_done		;Reset the check value
	rts					;Return to Black_Key Loop

Text:
	SetFont		#0			;Small Font
	WriteStr	#1,#123,#4,text1	;Write under the divider
	SetFont		#2			;Set to Large Font
	WriteStr	#60,#3,#4,text2		;Write Title at Top
	SetFont		#1			;Set Font to Normal

;*****************Check Keys and Set Key_Status*************
Main_Loop:
	GetKeyStat	#8			;Escape Pressed?
	btst		#6,d0
	beq		Exit
Z_Bit:
	GetKeyStat	#1			;Macro for Getting Row 1
	btst		#1,d0			;Test bit 1 of d0
	beq		Z_On			;If Pressed, Goto Z_On
	move.w		#0,z_stat		;Set z_stat to 0
	bra		S_Bit			;Branch to S_Bit
Z_On:
	move.w		#1,z_stat		;Set z_stat to 1
S_Bit:
	btst		#2,d0			;Repeat the process for all
	beq		S_On			;possible key presses that
	move.w		#1,s_stat		;matter
	bra		X_Bit
S_On:
	move.w		#0,s_stat
X_Bit:
	GetKeyStat	#2
	btst		#1,d0
	beq		X_On
	move.w		#0,x_stat
	bra		D_Bit	
X_On:
	move.w		#1,x_stat
D_Bit:
	btst		#2,d0
	beq		D_On
	move.w		#1,d_stat
	bra		C_Bit
D_On:
	move.w		#0,d_stat
C_Bit:
	GetKeyStat	#3,d0
	btst		#1,d0
	beq		C_On
	move.w		#0,c_stat
	bra		V_Bit
C_On:
	move.w		#1,c_stat
V_Bit:
	GetKeyStat	#4
	btst		#1,d0
	beq		V_On
	move.w		#0,v_stat
	bra		G_Bit	
V_On:
	move.w		#1,v_stat
G_Bit:
	btst		#2,d0
	beq		G_On
	move.w		#1,g_stat
	bra		B_Bit
G_On:
	move.w		#0,g_stat	
B_Bit:
	GetKeyStat	#5
	btst		#1,d0
	beq		B_On
	move.w		#0,b_stat
	bra		H_Bit	
B_On:
	move.w		#1,b_stat
H_Bit:
	btst		#2,d0
	beq		H_On
	move.w		#1,h_stat
	bra		N_Bit
H_On:
	move.w		#0,h_stat
N_Bit:
	GetKeyStat	#6
	btst		#1,d0
	beq		N_On
	move.w		#0,n_stat
	bra		J_Bit
N_On:
	move.w		#1,n_stat
J_Bit:
	btst		#2,d0
	beq		J_On
	move.w		#1,j_stat
	bra		M_Bit
J_On:
	move.w		#0,j_stat
M_Bit:
	GetKeyStat	#7
	btst		#1,d0
	beq		M_On
	move.w		#0,m_stat
	bra		Theta_Bit
M_On:
	move.w		#1,m_stat
Theta_Bit:
	GetKeyStat	#8
	btst		#1,d0
	beq		Theta_On
	move.w		#0,theta_stat
	bra		Keys_Done
Theta_On:
	move.w		#1,theta_stat

Keys_Done:
	PutKeyLabel	#33,#87,#90,z_stat		;Put Label on Key
	PutKeyLabel	#45,#61,#83,s_stat
	PutKeyLabel	#57,#87,#88,x_stat
	PutKeyLabel	#69,#61,#68,d_stat
	PutKeyLabel	#81,#87,#67,c_stat
	PutKeyLabel	#105,#87,#86,v_stat
	PutKeyLabel	#117,#61,#71,g_stat
	PutKeyLabel	#129,#87,#66,b_stat
	PutKeyLabel	#141,#61,#72,h_stat
	PutKeyLabel	#153,#87,#78,n_stat
	PutKeyLabel	#165,#61,#74,j_stat
	PutKeyLabel	#177,#87,#77,m_stat
	PutKeyLabel	#201,#87,#136,theta_stat
	Test_Sound	z_stat,#0,#1260			;Output Sound
	Test_Sound	s_stat,#1,#1184
	Test_Sound	x_stat,#0,#1117
	Test_Sound	d_stat,#1,#1057
	Test_Sound	c_stat,#0,#1003
	Test_Sound	v_stat,#0,#939
	Test_Sound	g_stat,#1,#883
	Test_Sound	b_stat,#0,#833
	Test_Sound	h_stat,#1,#788
	Test_Sound	n_stat,#0,#748
	Test_Sound	j_stat,#1,#703
	Test_Sound	m_stat,#0,#663
	Test_Sound	theta_stat,#0,#621
	bra		Main_Loop			;Branch Back

Exit:
	jsr		flib[idle_loop]			;To End With
	rts

;*********************Variables*******************
prog_name:      dc.b    "FPiano v1.0",129," by Matt House"0
wh_x1           dc.w    0
wh_y1           dc.w    0
blk_done	dc.w	0
text1		dc.b	"FPiano v1.0",129," ",169,"1997 by Matt House",0
text2		dc.b	"FPiano v1.0",129,0
z_stat		dc.w	0
s_stat		dc.w	0
x_stat		dc.w	0
d_stat		dc.w	0
c_stat		dc.w	0
v_stat		dc.w	0
g_stat		dc.w	0
b_stat		dc.w	0
h_stat		dc.w	0
n_stat		dc.w	0
j_stat		dc.w	0
m_stat		dc.w	0
theta_stat	dc.w	0
;****************End of Fargo Program***************

	reloc_open
	add_library     flib
	add_library     romlib
	add_library     linelib
	reloc_close
	end
